<?php
/*
 * e-academy ELMS Integrated User Verification
 */

session_start();
$_error = '';

if (isset($_POST['submit']) && $_POST['submit'] == 'Log In') 
{
	if (!isset($_POST['ccid']) || $_POST['ccid'] == '' || !isset($_POST['passwd']) || $_POST['passwd'] == '') 
	{
		$_error = '<p><font color="red">Authentication is Required.</font></p>';
	} 
	else 
	{
		$useUnsafeDemoBypass = 1;
		if ($useUnsafeDemoBypass == 1)
		{
			// for testing purposes, hard-code a success in order to test the handshake below
			// in a production implementation, this block should be removed and the following else block
			// should to be modified appropriately according to organization's implementation.

			$_SESSION['auth_ccid'] = $_POST['ccid'];
			$_SESSION['account_number'] = '110001111';
			$_SESSION['auth_email'] = 'jdoe@kivuto.com';
			$_SESSION['first_name'] = 'John';
			$_SESSION['last_name'] = 'Doe';
			$_SESSION['academic_statuses'] = 'staff,students,faculty';
			$_error = '';

			session_write_close();
		}
		else
		{
			// this block is a SAMPLE of how you may implement in production, although
			// the specific details will vary by implementation and must be determined
			// by the organization owning the verification engine.

			// set some sample but unusable values for demonstration purposes; fill in with real values
			$db_server_name = 'dbServer';
			$db_port = '443';
			$db_name = 'dbName';
			$db_user_name = 'dbUsername';
			$db_password = 'dbPassword';

			$conn = pg_connect("host=$db_server_name port=$db_port dbname=$db_name user=$db_user_name password=$db_password") 
				or die('Error! Could not connect: '.pg_last_error());

			$query = 'select statement must be created to fit your requirements of your organization';

			$result = pg_query($conn, $query);
			pg_close($conn);
			$isVerified = 0; // set to 1 on successful verification
			$num = pg_num_rows($result);

			if ($num == 1) 
			{
				$found_person = pg_fetch_array($result);
				$stored_password = $found_person[0];
				$passwd = stripslashes($passwd);
				$encrypted = crypt($passwd, substr($stored_password, 0, 2));
				if ($encrypted == $stored_password)
				{
					$isVerified = 1;
					$_SESSION['auth_ccid'] = $ccid;

					// fill the remaining in as required based on your organization's implementation
					$_SESSION['account_number'] = '';
					$_SESSION['auth_email'] = '';		
					$_SESSION['last_name'] = '';
					$_SESSION['first_name'] = '';
					$_SESSION['academic_statuses'] = '';
					session_write_close();
				} 
			}

			if ($isVerified == 0)
			{
				$_error = '<p><font color="red">Authentication Failed. Please try again.</font></p>';
			}
		}
	}
}

// user has been authenticated - handshake
if (isset($_SESSION['auth_ccid'])) 
{
	ob_start();

	$key = 'InsertYourKeyHere'; // replace with your webstore key
	$host = 'https://e5.onthehub.com/WebStore/Security/AuthenticateUser.ashx';

	// Build query body
	$data = array(
		'username'			=> $_SESSION['auth_ccid'],
		'account'			=> $_SESSION['account_number'],
		'email'				=> $_SESSION['auth_email'],
		'first_name'		=> $_SESSION['first_name'],
		'last_name'			=> $_SESSION['last_name'],
		'academic_statuses'	=> $_SESSION['academic_statuses'],
		'shopper_ip'		=> $_SERVER['REMOTE_ADDR'],
		'key'				=> $key
	);
	$options = array('http' =>
		array(
			'method'	=> 'POST',
			'header'	=> 'Content-type: application/json',
			'content'	=> json_encode($data)
		)
	);

	$context = stream_context_create($options);
	$e5LoginRedirectURL = file_get_contents($host, false, $context);

	// check response status code
	$http_status = $http_response_header[0];
	if (strpos($http_status, '200 OK') === false)	// NOTE $http_status may not always be $http_response_header[0]
	{
		// we have an error
		echo '<p><b>A handshake error has occured</b></p>';
		echo '<p><b>Response received:<br><font color="red">'.$http_status.'</font></b></p>';
	}
	else if (strlen($e5LoginRedirectURL) == 0)
	{
		// HTTP status code was OK but server didn't return a redirect URL; may be some other error, such as incorrectly configured server IP for your server
		echo '<p><b>A handshake error has occured; invalid redirection URL</b></p>';
	}
	else 
	{
		// status code looks good and we have a redirection URL; set redirect location in header
		header('Location: '.$e5LoginRedirectURL);
	}

	// clear session variables and destroy
	$_SESSION=array();
	if(isset($_COOKIE[session_name()])) 
	{
		setcookie(session_name(),'',time()-42000,'/');
	}
	@session_destroy();
	ob_end_flush();
	exit;
}

// unauthenticated user - show login
?>
<html>
<head>
<title>Login</title>
</head>

<div align="center">
	<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
		<?php echo $_error; ?><br />
		<p>Username<br />
		<input type="text" name="ccid" size="8" /></p>
		<p>Password:<br />
		<input type="password" name="passwd" size="15" /></p>
		<input type="submit" name="submit" value="Log In" /> 
		<input type="reset" name="reset" value="Clear" />
	</form>
</div>

</div>
</body>
</html>